/*-----------------------------------------------------------------------------*
// include
*-----------------------------------------------------------------------------*/
#include "harktool.h"




/*-----------------------------------------------------------------------------*
// extern
*-----------------------------------------------------------------------------*/
extern struct GLOBAL  g;






/*-----------------------------------------------------------------------------*
* 新規に配列を作成(main)
*
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_new(int type)
{

    switch (type) {
        //伝達関数用３次元配列を作成する(complex)
        //Nsrc x Nmic x Nfft/2+1
    case TF_VECT:
        g.TFvect = harktool_newComplexThreeDim(g.Nsrc , g.Nmic , (g.Nfft/2+1));
        break;


        //分離伝達関数用３次元配列を作成する(complex)
        //Nsrc x Nmic x Nfft/2+1
    case SEP_TF_VECT:
        g.SepTFvect = harktool_newComplexThreeDim(g.Nsrc , g.Nmic , (g.Nfft/2+1));
        break;



        //伝達関数作業用３次元配列を作成する(complex)
        //*  Nsrc x Nmic x Nfft/2+1
    case TMP_TF_VECT:
        g.TmpTFvect = harktool_newComplexThreeDim(g.Nsrc , g.Nmic , g.Nfft/2+1);
        break;

    case IR_VECT:
        //３次元配列を作成する(float) // Nsrc x Nmic x Nfft
        g.IRvect = harktool_newFloatThreeDim(g.Nsrc , g.Nmic , g.Nfft);
        break;

    case TMP_IR_VECT:
        //* impulse応答用領域を作成する //Nsrc x Nmic x Nfft
        g.TmpIRvect = harktool_newFloatThreeDim(g.Nsrc , g.Nmic , g.Nfft);
        break;

    case BACK_IR_VECT:
        //* impulse応答用領域を作成する //Nsrc x Nmic x Nfft
        g.BackIRvect = harktool_newFloatThreeDim(g.Nsrc , g.Nmic , g.Nfft);
        break;


        //インパルス応答(waveファイル)格納用２次元配列を作成する(float)
    case  WAV_DATA:
//        g.wav.data = harktool_newFloatTwoDim(  g.Nmic , g.Nfft );
        break;


        //mic position格納用２次元配列を作成する(float) // Nmic * 3 (x,y,z)
    case MIC_POS_VECT:
        g.MicPosVect = harktool_newFloatTwoDim(g.Nmic, 3);
        break;

    case SRC_POS_VECT:
        g.SrcPosVect = harktool_newFloatTwoDim(g.Nsrc, 3);
        break;


        //CalcSysimpで作成したImpulse応答ファイルパス設定領域を作成する (2次元配列)
        //* TSPファイル名格納領域を作成する (2次元配列)
    case FLT_PATH:
        g.tmp.flt_path = harktool_newCharTwoDim(g.Nsrc , PATH_LEN);
        break;

    case TSP_WAV_NAME:
        g.tmp.tsp_wav_name = harktool_newCharTwoDim(g.Nsrc , PATH_LEN);
        break;


    case IR_WAV_NAME:
//      harktool_newCharTwoDim( g.tmp.  .ir_wav_path , g.Nsrc , PATH_LEN );
        break;

    case SORT_POS_ID:
        g.MicPosId = harktool_newIntOneDim(g.Nmic);
        g.IrPosId  = harktool_newIntOneDim(g.Nsrc);
        g.TspPosId = harktool_newIntOneDim(g.Nsrc);
        break;

    case BUFFER:
        g.buff_a = harktool_newComplexOneDim(g.Nfft);
        g.buff_A = harktool_newComplexOneDim(g.Nfft);
        g.buff_w = harktool_newComplexOneDim(g.Nfft);
        break;

    }

}//end













/*-----------------------------------------------------------------------------*
* 配列をfreeする
*
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_delete(int type)
{


    switch (type) {
        //伝達関数用３次元配列を作成する(complex)
    case TF_VECT:
        harktool_freeComplexThreeDim(g.TFvect , g.Nsrc , g.Nmic);
        g.TFvect = NULL;
        break;

        //伝達関数作業用３次元配列を作成する(complex)
        //*  Nsrc x Nmic x Nfft/2+1
    case TMP_TF_VECT:
        harktool_freeComplexThreeDim(g.TmpTFvect , g.Nsrc , g.Nmic);
        g.TmpTFvect = NULL;
        break;

    case IR_VECT:
        //３次元配列を作成する(float) // Nsrc x Nmic x Nfft
        harktool_freeFloatThreeDim(g.IRvect , g.Nsrc , g.Nmic);
        g.IRvect = NULL;
        break;

    case TMP_IR_VECT:
        //* impulse応答用領域を作成する //Nsrc x Nmic x Nfft
        harktool_freeFloatThreeDim(g.TmpIRvect, g.Nsrc , g.Nmic);
        g.TmpIRvect = NULL;
        break;


    case BACK_IR_VECT:
        //* impulse応答用領域を作成する //Nsrc x Nmic x Nfft
        harktool_freeFloatThreeDim(g.BackIRvect , g.Nsrc , g.Nmic);
        break;


        //インパルス応答(waveファイル)格納用２次元配列を作成する(float)
    case  WAV_DATA:
        harktool_freeFloatTwoDim(g.wav.data , g.Nmic);
        g.wav.data  = NULL;
        break;


        //mic position格納用２次元配列を作成する(float) // Nmic * 3 (x,y,z)
    case MIC_POS_VECT:
        harktool_freeFloatTwoDim(g.MicPosVect, g.Nmic);
        g.MicPosVect = NULL;
        break;


        //CalcSysimpで作成したImpulse応答ファイルパス設定領域を作成する (2次元配列)
        //* TSPファイル名格納領域を作成する (2次元配列)
    case FLT_PATH:
        harktool_freeCharTwoDim(g.tmp.flt_path , g.Nsrc);
        g.tmp.flt_path = NULL;
        break;

    case TSP_WAV_NAME:
        harktool_freeCharTwoDim(g.tmp.tsp_wav_name , g.Nsrc);
        g.tmp.tsp_wav_name = NULL;
        break;


    case IR_WAV_NAME:
//      harktool_freeCharTwoDim( tmp.ir_wav_path , g.Nsrc  );
        break;

    case SORT_POS_ID:
        harktool_freeIntOneDim(g.MicPosId);
        harktool_freeIntOneDim(g.IrPosId);
        g.MicPosId = NULL;
        g.IrPosId = NULL;
        break;

    case BUFFER:
        harktool_freeComplexOneDim(g.buff_a);
        harktool_freeComplexOneDim(g.buff_A);
        harktool_freeComplexOneDim(g.buff_w);
        g.buff_a = NULL;
        g.buff_A = NULL;
        g.buff_w = NULL;
        break;

    }


}//









/*-----------------------------------------------------------------------------*
* 1次元配列
*
*
*
*-----------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------------*
* 1次元配列を作成する(int)
*
* IN : size_x
*
*-----------------------------------------------------------------------------*/
int* harktool_newIntOneDim(int size_x)
{

    int *m;

    m = (int*)malloc(size_x * sizeof(int)) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }

    return (m);
}



/*-----------------------------------------------------------------------------*
* 確保した配列を解放(complex)
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeIntOneDim(int* matrix)
{

    if (matrix == NULL) {
        return;
    }


    if (matrix != NULL) {
        free(matrix);
        matrix = NULL;
    }
}








/*-----------------------------------------------------------------------------*
* 1次元配列を作成する(complex)
*
* IN : size_x
* OUT: (complex***)matrix
*
*-----------------------------------------------------------------------------*/
COMPLEX_FLOAT* harktool_newComplexOneDim(int size_x)
{


    COMPLEX_FLOAT *m ;

    m = (COMPLEX_FLOAT*)malloc(size_x * COMPLEX_FLOAT_SIZE) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }

    return (m);
}



/*-----------------------------------------------------------------------------*
* 確保した配列を解放(complex)
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeComplexOneDim(COMPLEX_FLOAT* matrix)
{

    if (matrix != NULL) {
        free(matrix);
        matrix = NULL;
    }

}







/*-----------------------------------------------------------------------------*
* 2次元配列
*
*
*
*-----------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------------*
* 2次元配列作成（char）
*
*
*
*-----------------------------------------------------------------------------*/
char** harktool_newCharTwoDim(int size_x , int size_y)
{

    int src;
    char **m;

    m = (char**)malloc(sizeof(char*) * size_x) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }


    for (src=0 ; src<size_x ; src++) {
        m[src] = (char*)malloc(sizeof(char) * size_y);

        if (m[src] == NULL) {
            harktool_LogE("can not allocated memory");
            harktool_Exit(EXIT_FAILURE);
        }

        memset(m[src] , '\0' , sizeof(char) * size_y);
    }

    return (m);

}//end








/*-----------------------------------------------------------------------------*
* 確保した2次元配列を解放
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeCharTwoDim(char **matrix , int size_x)
{

    int i;

    if (matrix == NULL) return;

    /* 確保した配列を解放 */
    for (i=0 ; i < size_x  ; i++) {
        if (matrix[i] != NULL) {
            free(matrix[i]);
            matrix[i] = NULL;
        }
    }

    if (matrix != NULL)  free(matrix);
    matrix = NULL;

}













/*-----------------------------------------------------------------------------*
* 2次元配列を作成する(float)
*  size_x * size_y
*
*
*-----------------------------------------------------------------------------*/
float** harktool_newFloatTwoDim(int size_x , int size_y)
{

    int i;
    float **m;


    /* size_x 分のアドレス格納領域を確保 */
    m = (float**)malloc(sizeof(float*) * size_x) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }


    /* size_y分 のfloatデータ格納領域を確保 */
    for (i=0 ; i < size_x ; i++) {
        m[i] = (float*)malloc(sizeof(float) * size_y);

        if (m[i] ==NULL) {
            harktool_LogE("can not allocated memory");
            harktool_Exit(EXIT_FAILURE);
        }

        memset(m[i] , '\0' , sizeof(float) * size_y);

    }

    return (m);


}//end







/*-----------------------------------------------------------------------------*
* 確保した2次元配列を解放(float)
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeFloatTwoDim(float** matrix , int size_x)
{

    int i;

    if (matrix == NULL) return;


    /* 確保した配列を解放 */
    for (i=0 ; i < size_x ; i++) {
        if (matrix[i] != NULL) {
            free(matrix[i]);
            matrix[i] = NULL;
        }
    }

    if (matrix != NULL)  free(matrix);
    matrix = NULL;

}










/*-----------------------------------------------------------------------------*
* 3次元配列
*
*
*
*-----------------------------------------------------------------------------*/




/*-----------------------------------------------------------------------------*
* ３次元配列を作成する(float)
*  Nsrc x Nmic x Nfft
*
*
*-----------------------------------------------------------------------------*/
float*** harktool_newFloatThreeDim(int size_x , int size_y , int size_z)
{

    int src,mic;
    float ***m;

    /* size_x × size_y × size_z の配列を確保 */
    m = (float***)malloc(sizeof(float**) * size_x) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }


    for (src=0 ; src < size_x ; src++) {
        m[src] = (float**)malloc(sizeof(float*) * size_y);

        if (m[src] ==NULL) {
            harktool_LogE("can not allocated memory");
            harktool_Exit(EXIT_FAILURE);
        }


        for (mic=0 ; mic < size_y ; mic++) {
            m[src][mic] = (float *)malloc(sizeof(float) * size_z);

            if (m[src][mic] ==NULL) {
                harktool_LogE("can not allocated memory");
                harktool_Exit(EXIT_FAILURE);
            }

            memset(m[src][mic] , '\0' , sizeof(float) * size_z);

        }
    }


    return (m);

}//end












/*-----------------------------------------------------------------------------*
* 確保した配列を解放(float)
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeFloatThreeDim(float*** matrix , int size_x, int size_y)
{

    int i,j;

    if (matrix == NULL) return;


    /* 確保した配列を解放 */
    for (i=0 ; i < size_x ; i++) {
        for (j=0 ; j < size_y ; j++) {
            if (matrix[i][j] != NULL) {
                free(matrix[i][j]);
                matrix[i][j] = NULL;
            }
        }

        if (matrix[i] != NULL) {
            free(matrix[i]);
            matrix[i] = NULL;
        }
    }

    if (matrix !=NULL)  free(matrix);

    matrix = NULL;

}

























/*-----------------------------------------------------------------------------*
* 3次元配列
*
*
*
*-----------------------------------------------------------------------------*/



/*-----------------------------------------------------------------------------*
* ３次元配列を作成する(complex)
*
* IN : size_x(Nsrc) x size_y(Nmic) x size_z( Nfft/2+1 )
* OUT: (complex***)matrix
*
*-----------------------------------------------------------------------------*/
COMPLEX_FLOAT*** harktool_newComplexThreeDim(int size_x , int size_y , int size_z)
{


//    printf("size_x[%d] size_y[%d] size_z[%d]\n" , size_x,size_y,size_z);

    int src,mic;
    COMPLEX_FLOAT ***m;

    //Nsrc
    m = (COMPLEX_FLOAT***)malloc(sizeof(COMPLEX_FLOAT**) * size_x) ;

    if (m == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_Exit(EXIT_FAILURE);
    }



    for (src=0 ; src < size_x  ; src++) {
        m[src] = (COMPLEX_FLOAT**)malloc(sizeof(COMPLEX_FLOAT*) * size_y);

        if (m[src] ==NULL) {
            harktool_LogE("can not allocated memory");
            harktool_Exit(EXIT_FAILURE);
        }


        for (mic=0 ; mic < size_y  ; mic++) {
            m[src][mic] = (COMPLEX_FLOAT *)malloc(sizeof(COMPLEX_FLOAT) * size_z);

            if (m[src][mic] ==NULL) {
                harktool_LogE("can not allocated memory");
                harktool_Exit(EXIT_FAILURE);
            }

            memset(m[src][mic] , '\0' , sizeof(COMPLEX_FLOAT) * size_z);

        }

    }//src





    return (m);

}//end





/*-----------------------------------------------------------------------------*
* 確保した配列を解放(complex)
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeComplexThreeDim(COMPLEX_FLOAT*** matrix , int size_x, int size_y)
{

    int i,j;

    if (matrix == NULL) {
        return;
    }


    /* 確保した配列を解放 */
    for (i=0 ; i < size_x ; i++) {
        for (j=0 ; j < size_y ; j++) {
            if (matrix[i][j] != NULL) {
                free(matrix[i][j]);
                matrix[i][j] = NULL;
            }
        }

        if (matrix[i] != NULL) {
            free(matrix[i]);
            matrix[i] = NULL;
        }
    }

    if (matrix != NULL) {
        free(matrix);
        matrix = NULL;
    }

}//end





/*-----------------------------------------------------------------------------*
* ３次元配列データを初期化する(complex)
*
* Nsrc x Nmic x Nfft/2+1
*
*
*-----------------------------------------------------------------------------*/
void harktool_initArray(int type)
{

    int src, mic ;


    switch (type) {
    case TMP_IR_VECT:
        for (src = 0; src < g.Nsrc ; src++) {
            for (mic = 0 ;  mic < g.Nmic ;  mic++) {
                memset(g.TmpIRvect[src][mic] , '\0' , sizeof(float) * g.Nfft);
            }
        }

        break;

    case TMP_TF_VECT:
        for (src = 0; src < g.Nsrc ; src++) {
            for (mic = 0 ;  mic < g.Nmic ;  mic++) {
                memset(g.TmpTFvect[src][mic] , '\0' , sizeof(COMPLEX_FLOAT) * (g.Nfft/2+1)) ;
            }
        }

        break;
    }

}//end
















/*-----------------------------------------------------------------------------*
* float型からmatrix型へ変換する
*
* in  : flat_chxx.flt
* out : param.IRvector
*
*-----------------------------------------------------------------------------*/
void harktool_setIRvectFromFlt(int src)
{

    float *fltBuf;
    int   start;
    char  fname[PATH_LEN];
    int   mic,fft;

    for (mic=0 ; mic< g.Nmic ; mic++) {
        memset(fname  , '\0' , PATH_LEN);
        sprintf(fname , "%s/float_ch%d.flt" , g.tmp.flt_path[src] , mic+1);    // float_ch1.flt


        // 1flt file size 取得(16384byte)
        long file_size = 0 ;
        harktool_getFileSize(fname , &file_size);


        // 1flt file size 取得(16384byte)
        fltBuf = NULL;
        fltBuf = (float *)malloc(file_size);

        if (fltBuf == NULL) {
            harktool_LogE("can not allocated memory");
            harktool_Exit(EXIT_FAILURE);
        }


        //1ch分の file のデータをbufferに格納する
        harktool_SetFloatArray(fltBuf , file_size , fname);

        // cut_start / cut_end
        start = 0;

        if (g.PeakSearchFrom > 0) {
            start = g.PeakSearchFrom;
        }


        // FFT長(512)分のみ設定する
        for (fft = start ; fft < (g.Nfft + start) ; fft++) {
            //IRvector[npos][Nmic][Nfft]
            g.IRvect[src][mic][fft] = fltBuf[fft];
        }

        free(fltBuf);

    }//mic

}//







/*-----------------------------------------------------------------------------*
* Impulse応答のwav fileを読み込んで配列に格納する
*
*
* in  : wave.data[mic][fft];
* out : param.IRvector
*
*-----------------------------------------------------------------------------*/
void harktool_setIRvectFromWav()
{

    int   src,mic,fft;
    int   start;
    int   ir_id;
    harkio_Position* pos;


    for (src=0 ; src<g.Nsrc ; src++) {

        ir_id = g.IrPosId[src] ;//昇順でsort済


        //mic_idのpositionを取得
        pos = harkio_Positions_getById(g.impulse_xml->poses , ir_id);


        // file のデータをbuffer(g.wave.data[ch][])に格納する
        harktool_getWavDataFromFile(pos->path);


        // cut_start / cut_end
        start = 0;

        if (g.PeakSearchFrom > 0) {
            start = g.PeakSearchFrom;
        }


        for (mic=0 ; mic< g.Nmic ; mic++) {
            // FFT長分(512)のみ設定する
            for (fft = start ; fft < (g.Nfft + start) ; fft++) {
                //IRvector[npos][Nmic][Nfft]
                g.IRvect[src][mic][fft] = g.wav.data[mic][fft];
            }
        }

    }

}//











/*-----------------------------------------------------------------------------*
指定されたフレーム数だけ読み込む
* read wave file
*
* wave[mic][data]
*

channel 0 2 4 ・・・ n-1 | j channels
channel 1 3 5 ・・・ n   |
        |-------------|
            i frames

            i*j = n item
     read n item


------- 32767
   〜
------- 1

------- 0

------- -1
   〜
------- -32767


入力ファイルのフォーマットは 16bit

    data = ch1 ,ch2 ,ch3 ・・・ch7, ch1 ,ch2 ,ch3 ・・・ch7 , ・・・


calcSysImp --tsporigwav "/usr/bin/harktool4_utils/16384.little_endian.wav" --sigmax "32768" --syncaddfreq "16" --syncaddoffset "16384" --outchannellist "0,1,2,3,4,5,6,7" "/home/takenaka/TEST_SMARTROOM/no-cover/IR_smartroom_20111031_circle360_5deg_H115_R150_D180_1.wav" "/tmp/3ebf-e3ad-9ef5-52c4/home/takenaka/TEST_SMARTROOM/no-cover/IR_smartroom_20111031_circle360_5deg_H115_R150_D180_1.wav/float"


//sf_count_t  sf_readf_float   (SNDFILE *sndfile, float *ptr, sf_count_t frames) ;
*-----------------------------------------------------------------------------*/
void harktool_getWavDataFromFile(char *fname)
{

    SNDFILE *fp ;    // ファイルハンドラ
    SF_INFO sfinfo; // チャンネル数、サンプリング周波数などを持つ構造体

    // sf_open の前に 0 にしておく
    sfinfo.format = 0;
    int mic,frame;
    float *in_buf;
    int read_num;
    int frames;
    sf_count_t ndata;

    if ((fp = sf_open(fname, SFM_READ, &sfinfo)) == NULL) {
        harktool_LogE("can not open wave file");
        harktool_Exit(EXIT_FAILURE);
    }


    //check channel
    if (sfinfo.channels != g.Nmic) {
        sf_close(fp);
        char msg[MSG_LEN];
        sprintf(msg, "different number of microphones: wav channels[%d] mic-file[%d]", sfinfo.channels, g.Nmic);
        harktool_LogE(msg);
        harktool_Exit(EXIT_FAILURE);
    }


    // 読み込む frame数
    ndata = 1; //1frame分
    frames = sfinfo.frames;


    in_buf = (float*)malloc(sizeof(float) *  g.Nmic);

    if (g.wav.data == NULL) {
        g.wav.data = harktool_newFloatTwoDim(g.Nmic ,  frames);
    }



    for (frame = 0; frame < frames ; frame++) {
        read_num = sf_readf_float(fp, in_buf , ndata); //1frame分

        if (read_num != ndata) {
            char msg[MSG_LEN];
            sprintf(msg, "read count different. read_num=%d count=%d", read_num, (int)ndata);
            harktool_LogE(msg);
            free(in_buf);
            sf_close(fp);
            harktool_Exit(EXIT_FAILURE);
        }

        for (mic = 0; mic< g.Nmic ; mic++) {
            g.wav.data[mic][frame] =  in_buf[mic];
        }
    }


    sf_close(fp);
    free(in_buf);


}










/*-----------------------------------------------------------------------------*
* ユニークなディレクトリ名作成用に現在日時分秒を取得
*
*
*  OUT : param.date_time    //取得した時間の文字列
*-----------------------------------------------------------------------------*/
void harktool_getLocaltime(char *buff)
{

    time_t timer;
    struct tm *local;


    /* 現在時刻を取得 */
    timer = time(NULL);

    local = localtime(&timer);

    /* 変換後表示 */
    sprintf(buff ,  "%4d%02d%02d%02d%02d%02d"  , local->tm_year + 1900
            , local->tm_mon + 1
            , local->tm_mday
            , local->tm_hour
            , local->tm_min
            , local->tm_sec);

}//end











/*-----------------------------------------------------------------------------*
*
* /tmp配下に使用するディレクトリを作成する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_createTmpPath()
{

    int  cnt;
    char path_name[BUFFSIZE];


    if (harktool_CheckDir("/tmp") == NON_DIR_TYPE) {
        harktool_LogE("None [/tmp] Directory");
        harktool_Exit(EXIT_FAILURE);
    }


    if (harktool_CheckDir("/tmp/harktool") == NON_DIR_TYPE) {
        harktool_createDir("/tmp/harktool");
    }


    cnt = 0;
    while (cnt <= 5) { // 5回試みる
        harktool_getLocaltime(g.tmp.date_time);   //作成日時

        memset(path_name , '\0' , sizeof(path_name))  ;
        sprintf(path_name , "%s/%s" , "/tmp/harktool" , g.tmp.date_time);

        if (harktool_CheckDir(path_name) == NON_DIR_TYPE) {
            if (harktool_createDir(path_name) == SUCCESS) {
                break;
            }
        }

        cnt++ ;
        sleep(1);
        printf("<< retry create directory >>\n");
    }

    //Directory check
    if (harktool_CheckDir(path_name) == NON_DIR_TYPE) {
        harktool_LogE("can not create directory");
        harktool_Exit(EXIT_FAILURE);
    }




    //set Directory Name
    sprintf(g.tmp.tsp_path , "%s/tsp" , path_name);

    if (harktool_CheckDir(g.tmp.tsp_path) == NON_DIR_TYPE) {
        harktool_createDir(g.tmp.tsp_path);
    }


    sprintf(g.tmp.ir_path  , "%s/imp" , path_name);

    if (harktool_CheckDir(g.tmp.ir_path) == NON_DIR_TYPE) {
        harktool_createDir(g.tmp.ir_path);
    }


    sprintf(g.tmp.tf_path, "%s/tf" , path_name);

    if (harktool_CheckDir(g.tmp.tf_path) == NON_DIR_TYPE) {
        harktool_createDir(g.tmp.tf_path);
    }


}//end










/*-----------------------------------------------------------------------------*
* ディレクトリの有無を確認する
*
*  0:directory -1: non directory
*
*
*-----------------------------------------------------------------------------*/
int harktool_CheckDir(char *dirname)
//int harktool_CheckDir( char *dirname )
{

    struct stat sb;
    int ret = NON_DIR_TYPE;

    if (stat(dirname , &sb) == 0) {
        switch (sb.st_mode & S_IFMT) {
        case S_IFDIR: //0040000 ディレクトリ
            ret = DIR_TYPE;
            break;

        default:
            ret = NON_DIR_TYPE;
            break;
        }
    }

    return (ret);


}//end










/*-----------------------------------------------------------------------------*
* ディレクトリ を作成する
*
*
*
*-----------------------------------------------------------------------------*/
int harktool_createDir(char* path)
{



    if (mkdir(path , 0755) == 0) {  //0:成功 -1:error
        return (SUCCESS);
    }

    return (FAILURE);

}












/*-----------------------------------------------------------------------------*
*
* 文字列を区切り文字で、分割する
*
*  IN   : char *str          // 分割したい文字列
*       : const char *delim  // 区切り文字
*       : char *outlist[]    // 分割後の文字列
*
*  OUT  : 分割後文字列数
*
*-----------------------------------------------------------------------------*/
int harktool_split(char *str, const char *delim,  int *outlist)
{
    char    *tk;
    int     cnt = 0;

    tk = strtok(str, delim);

    while (tk != NULL) {
        outlist[cnt] = atoi(tk)+1;
        cnt++;
        tk = strtok(NULL, delim);
    }

    return cnt;
}










/*-----------------------------------------------------------------------------*
* file sizeを取得する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_getFileSize(char* filename  , long *size)
{

    FILE *fp;


    fp = fopen(filename, "rb");

    if (fp == NULL) {
        char msg[MSG_LEN];
        sprintf(msg, "can not open file [%s]", filename);
        harktool_LogE(msg);
        harktool_Exit(EXIT_FAILURE);
    }

    fseek(fp, 0, SEEK_END);
    *size = ftell(fp);

    //printf( "%sファイルのサイズ:%d バイト", fname, sz );

    fclose(fp);

}//end








/*-----------------------------------------------------------------------------*
* 1ファイルのデータをbufferに格納する
*
*
* Argument:
*
*  OUT : float *fltBuf // 格納先buffer
*  IN  : long size     // ファイルサイズ
*  IN  * char *fname   // 対象ファイル名
*
*-----------------------------------------------------------------------------*/
void harktool_SetFloatArray(float *fltBuf , long file_size , char *fname)
{

    float read_buf ; // read buffer
    float size ,sz;
    FILE *fp;
    int i;

    fp = fopen(fname, "rb");

    if (fp == NULL) {
        char msg[MSG_LEN];
        sprintf(msg, "can not open file [%s]", fname);
        harktool_LogE(msg);
        harktool_Exit(EXIT_FAILURE);
    }

    size = file_size/sizeof(float);

    for (i=0 ; i< size ; i++) {
        sz = fread((void*)&read_buf , sizeof(float) , 1 , fp) ;
        if (sz == 1) {
            fltBuf[i] = read_buf;
        } else {
            harktool_LogE("fread error");
            fclose(fp);
            harktool_Exit(EXIT_FAILURE);
        }
    }

    fclose(fp);

}//end









/*-----------------------------------------------------------------------------*
* 音源(SRC)ごとにインパルス応答を正規化する.
*
* in  : param.IRvector
* out : param.tmp_IRvector
*-----------------------------------------------------------------------------*/
void harktool_normalizeIR()
{

    float sum;
    int src;


    // tmp領域にcopy
    harktool_copyTmpIRvectToTMP();


    //全データ(param.tmp_IRvector)を２乗
    harktool_powIR();


    //srcごとに総数を取得して、２乗した各データで割る
    for (src = 0; src < g.Nsrc ; src++) {
        // g.tmp_IRvect_vectorの総数を取得
        sum = harktool_sumAll(src , normalize_src);

        // 多次元配列のすべての要素を指定した数値で割る
        // IRvector = tmp_IRvector/sum
        harktool_divAll(src , sum , normalize_src);
    }
}//end








/*-----------------------------------------------------------------------------*
* 伝達関数を正規化する.
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_normalizeTF()
{


    // vector.TmpTFvectを初期化
    harktool_initArray(TMP_TF_VECT);


    //TFの最後の要素を"0"クリアする
    harktool_setZeroToTFvect();


    // vector.TFvect を vector.temp_tf にcopy
    harktool_copyTmpTFvectFromTFvect();



    //全データを絶対値にし、vector.TmpTFvectにセット
    harktool_absTF();

    //全データを2乗する(g.TmpTFvect)
    harktool_powTF();



    //各正規化処理
    if (g.argv.normalize_src == 1) {
        harktool_normalizeSRC();
    }

    if (g.argv.normalize_mic == 1) {
        harktool_normalizeMIC();
    }


    if (g.argv.normalize_freq == 1) {
        harktool_normalizeFREQ();
    }



}//end









/*-----------------------------------------------------------------------------*
* 音源(SRC)ごとに伝達関数を正規化する.
*
*
* in  : TmpTFvector
* out : tf_vector
*
*-----------------------------------------------------------------------------*/
void harktool_normalizeSRC()
{

    int src,mic,fft;
    float sqrt_sum = 0 ;
    float sum      = 0 ;
    float real,imag;


    for (mic = 0 ;  mic < g.Nmic ;  mic++) {
        for (fft = 0; fft < (g.Nfft/2 + 1) ; fft++) {
            sum = 0;

            for (src = 0; src < g.Nsrc ; src++) {
                //crealf 関数は，float complex 型の複素数 z の実部を float 型で返します
                sum = sum + crealf(g.TmpTFvect[src][mic][fft]);
            }

            sqrt_sum = sqrtf(sum); //

            if (isfinite(sqrt_sum)!=0 && sqrt_sum != 0) {
                for (src = 0; src < g.Nsrc ; src++) {
                    real = crealf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る
                    imag = cimagf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る

                    g.TFvect[src][mic][fft] =  real + imag *  _Complex_I;

                }
            }
        }
    }

}



/*-----------------------------------------------------------------------------*
* @brief MICごとに伝達関数を正規化する.
*
* sqrtf 関数は引数 x の平方根を計算し，結果を float 型で返します．
*
* in  : TmpTFvector
* out : tf_vector
*
*
*-----------------------------------------------------------------------------*/
void harktool_normalizeMIC()
{

    int src,mic,fft;

    float sqrt_sum = 0 ;
    float sum      = 0 ;
    float real,imag;


    for (src = 0; src < g.Nsrc ; src++) {
        for (fft = 0; fft < (g.Nfft/2 + 1) ; fft++) {
            sum = 0;

            for (mic = 0 ;  mic < g.Nmic ;  mic++) {
                //crealf 関数は，float complex 型の複素数 z の実部を float 型で返します
                sum = sum + crealf(g.TmpTFvect[src][mic][fft]);
            }

            sqrt_sum = sqrtf(sum); //

            if (isfinite(sqrt_sum)!=0 && sqrt_sum != 0) {
                for (mic = 0 ;  mic < g.Nmic ;  mic++) {
                    real = crealf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る
                    imag = cimagf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る

                    g.TFvect[src][mic][fft] =  real + imag *  _Complex_I;

                }
            }
        }
    }

}









/*-----------------------------------------------------------------------------*
* @brief 周波数(FRQ)ごとに伝達関数を正規化する.
*
*
*
* in  : TmpTFvector
* out : tf_vector
*
*-----------------------------------------------------------------------------*/
void harktool_normalizeFREQ()
{

    int src,mic,fft;

    float sqrt_sum = 0 ;
    float sum      = 0 ;
    float real,imag;


    for (src = 0; src < g.Nsrc ; src++) {
        for (mic = 0 ;  mic < g.Nmic ;  mic++) {
            sum = 0;

            for (fft = 0; fft < (g.Nfft/2 + 1) ; fft++) {
                //crealf 関数は，float complex 型の複素数 z の実部を float 型で返します
                sum = sum + crealf(g.TmpTFvect[src][mic][fft]);
            }

            sqrt_sum = sqrtf(sum); //

            if (isfinite(sqrt_sum)!=0 && sqrt_sum != 0) {
                for (fft = 0; fft < (g.Nfft/2 + 1) ; fft++) {
                    real = crealf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る
                    imag = cimagf(g.TFvect[src][mic][fft]) / sqrt_sum ; //normで割る

                    g.TFvect[src][mic][fft] =  real + imag *  _Complex_I;

                }
            }
        }
    }

}








/*-----------------------------------------------------------------------------*/
/** @brief 残響音を取り除く.(IRvectのpeak値からdirect_sound_length分以降を"0"にする)
 * @param IRvect NSRC x NMIC x NFFTの3次元配列
 * @param sources 音源配列
 * @param direct_sound_length 直接音とみなす信号長

 // 残響音と思われる部分に0を書き込む

*
* in  : param.IRvector
* out : param.IRvector
*
*
-----------------------------------------------------------------------------*/
void harktool_EraseReverberation()
{

    int src , mic;
    int i , fill_start_pos;
    int top_index;


    for (src = 0; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {

            if (0 < g.PeakSearchTo) {

                if (g.Nfft <= g.PeakSearchTo) {
                    printf("cut_end exceeds the number of FFT: src %d"  ,src) ;
                    continue;
                } else {
                    //カット開始位置に移動
                    fill_start_pos = g.PeakSearchTo;
                }
            } else {
                top_index = harktool_FindTop(src ,mic);

                // 反響音の位置distを計算
                int dist = top_index + 1 + g.argv.direct_sound_length;

                if (dist < g.Nfft) {
                    fill_start_pos =  dist ;
                } else {
                    fill_start_pos = g.Nfft -1 ;
                }
            }

            // IRvectorの反響音をクリア
            for (i=fill_start_pos ; i< g.Nfft ; i++) {
                g.IRvect[src][mic][i] = 0.0f ;
            }

        }
    }
}








/*-----------------------------------------------------------------------------*
* 残響音が直接音より大きい可能性がある音源を表示
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_ShowReverbSources()
{

    int src , mic ;
    int count ;
    int top_index ;


    count=0;

    for (src = 0; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {

            top_index = harktool_FindTop(src ,mic);

            // インパルス応答の最大値が200(DIRECT_SOUND_POSITION_LIMIT)以上の場合を記録
            if ((int)DIRECT_SOUND_POSITION_LIMIT <= top_index) {
                if (count == 0) {
                    printf("\n");
                    printf("     ----------------------------------------------------------------------------\n");
                    printf("            Direct sound <  Reverberant sound                                    \n");
                    printf("     ----------------------------------------------------------------------------\n");
                }

                switch (g.PosType) {
                case TSP:
                    printf("[ %s ]  Mic:[%d]ch   Max Peak Index[%d]\n" , g.tsp_xml->poses->pos[src]->path , mic , top_index);
                    break;

                case IMPULSE:
                    printf("[ %s ]  Mic:[%d]ch   Max Peak Index[%d]\n" , g.impulse_xml->poses->pos[src]->path , mic , top_index);
                    break;
                }


                count++;
            }
        }
    }
}









/*-----------------------------------------------------------------------------*
* fft 実行
*
* 1. vector.buff_a <- IRvector
* 2. TFvect <- fft()
*
* c = std::complex< double >( 3.0, 4.0 );
*
*
* in  : vector.IRvect
* out : vector.IRvect
*
*-----------------------------------------------------------------------------*/
void harktool_FFT()
{

    int src, mic ,fft;



    memset(g.buff_a , '\0' , g.Nfft  * sizeof(COMPLEX_FLOAT));
    memset(g.buff_A , '\0' , g.Nfft  * sizeof(COMPLEX_FLOAT));


    for (src = 0; src < g.Nsrc ; src++) {
        for (mic = 0 ;  mic < g.Nmic ;  mic++) {
            for (fft = 0; fft < g.Nfft ; fft++) {
                g.buff_a[fft] =  g.IRvect[src][mic][fft] + 0.0f * _Complex_I;
                g.buff_A[fft] =  g.IRvect[src][mic][fft] + 0.0f * _Complex_I;
            }

            // fft実行 a[]の値をfftした結果がA[]にセットされる
            // harktool_calcFloatFFT( g.buff_a , g.buff_A  );
            harktool_FFTImpl_fFFT(g.buff_a, g.buff_A, g.Nfft);


            //Nfft/2 +1分コピー
            for (fft = 0; fft < g.Nfft/2 +1  ; fft++) {
                g.TFvect[src][mic][fft] =  crealf(g.buff_A[fft]) + cimagf(g.buff_A[fft]) * _Complex_I;
            }
        }
    }
}












/*-----------------------------------------------------------
* 伝達関数をconjする
*
*
*  conjf 関数は，複素数 z の共役複素数を float complex 型で返します
*
*
* in  : g.IRvect
* out : g.TFvect
*
-----------------------------------------------------------*/
void harktool_conjTF()
{

    int src, mic ,fft;

    for (src = 0; src < g.Nsrc ; src++) {
        for (mic = 0 ;  mic < g.Nmic ;  mic++) {
            for (fft = 0; fft < (g.Nfft/2+1) ; fft++) {
                g.TFvect[src][mic][fft] = conjf(g.TFvect[src][mic][fft]);
            }
        }
    }
}









/*-----------------------------------------------------------------------------*
* インパルス応答 最大値を求める
*
* out : int top_index
*
*-----------------------------------------------------------------------------*/
int harktool_FindTop(int src, int mic)
{

    int i;
    int top_index =0;
    float max ;

    float *Bufvect = (float *)malloc(g.Nfft * sizeof(float));    //Nfft分



    // g.IRvectの絶対値を求め、IRvectに格納 ( float fabsf(float x) )
    for (i=0 ; i < g.Nfft ; i++) {
        Bufvect[i] = fabsf(g.IRvect[src][mic][i]);
    }



    // 最大値の位置を探す
    max = Bufvect[0];


    for (i=1 ; i< g.Nfft ; i++) {
        if (max < Bufvect[i]) {
            max = Bufvect[i];
            top_index = i;
        }
    }

    free(Bufvect);

    return top_index;
}





/*-----------------------------------------------------------------------------*
*  g.TFvect のデータを、g.TmpTFvect にcopyする
*
* in  : g.TFvect
* out : g.TmpTFvect
*-----------------------------------------------------------------------------*/
void harktool_copyTmpTFvectFromTFvect()
{
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < (g.Nfft/2+1) ; fft++) {
                g.TmpTFvect[src][mic][fft] =  crealf(g.TFvect[src][mic][fft])  + cimagf(g.TFvect[src][mic][fft]) * _Complex_I;
            }
        }
    }
}








/*-----------------------------------------------------------------------------*
*  g.SepTFvect のデータを、g.TFvect にcopyする
*
* in  : g.SepTFvect
* out : g.TFvect
*-----------------------------------------------------------------------------*/
void harktool_copyTFvectFromSepTFvect()
{
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < (g.Nfft/2+1) ; fft++) {
                g.TFvect[src][mic][fft] =  crealf(g.SepTFvect[src][mic][fft])  + cimagf(g.SepTFvect[src][mic][fft]) * _Complex_I;
            }
        }
    }
}









/*-----------------------------------------------------------------------------*
* g.IRvect のデータを、g.tmp_IRvectにcopyする
*
* in  : g.IRvect
* out : g.tmp_IRvect
*-----------------------------------------------------------------------------*/
void harktool_copyTmpIRvectToTMP()
{
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < g.Nfft ; fft++) {
                g.TmpIRvect[src][mic][fft] = g.IRvect[src][mic][fft];
            }
        }
    }
}





/*-----------------------------------------------------------------------------*
* g.IRvect のデータを、g.BackIRvectにcopyする
*
* in  : g.IRvect
* out : g.tmp_IRvect
*-----------------------------------------------------------------------------*/
void harktool_copyIRvectToBackIRvect()
{
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < g.Nfft ; fft++) {
                g.BackIRvect[src][mic][fft] = g.IRvect[src][mic][fft];
            }
        }
    }
}





/*-----------------------------------------------------------------------------*
* g.BackIRvect  のデータを、g.IRvectにRecoveryする
*
* in  : g.IRvect
* out : g.tmp_IRvect
*-----------------------------------------------------------------------------*/
void harktool_copyBackIRvectToIRvect()
{
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < g.Nfft ; fft++) {
                g.IRvect[src][mic][fft]  = g.BackIRvect[src][mic][fft];
            }
        }
    }
}










/*-----------------------------------------------------------------------------*
* tf のデータを絶対値し、tmp_tfにセットする
*
* in  : g.TmpTFvect
* out : g.TmpTFvect
*-----------------------------------------------------------------------------*/
void harktool_absTF()
{

    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0 ; fft < (g.Nfft/2+1) ; fft++) {
                //cabsf 関数は，float complex 型の引数 z の絶対値を float 型で返します
                g.TmpTFvect[src][mic][fft] = cabsf(g.TmpTFvect[src][mic][fft]);
            }
        }
    }
}




/*-----------------------------------------------------------------------------*
* powf
*
*
*
*-----------------------------------------------------------------------------*/
float harktool_pow(float a , int cnt)
{


    int i;
    float buf;

    buf = 1.0f;

    for (i=0 ; i<cnt ; i++) {
        buf = buf * a ;
    }

    return buf;

}//end






/*-----------------------------------------------------------------------------*
* tmp_tf の全値を2 乗する
*
* x の 2 乗を計算し，結果を float 型で返します
*
* in   : g.TmpTFvect
* out  : g.TmpTFvect
*
*
*-----------------------------------------------------------------------------*/
void harktool_powTF()
{

    COMPLEX_FLOAT value_a;
    int src,mic,fft;

    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0; fft < (g.Nfft/2+1); fft++) {
                value_a = g.TmpTFvect[src][mic][fft];

                g.TmpTFvect[src][mic][fft] = value_a * value_a; //

                //cpowf 関数は，x の y 乗を計算し，結果を float complex 型で返します．
                //g.TmpTFvect[src][mic][fft] =  crealf(value) + cimagf(value) * _Complex_I;
            }
        }
    }

}













/*-----------------------------------------------------------------------------*
* ir の全値を2 乗する
*
* x の 2 乗を計算し，結果を float 型で返します
*
* in  : g.tmp_IRvect
* out : g.tmp_IRvect
*
*-----------------------------------------------------------------------------*/
void harktool_powIR()
{

    COMPLEX_FLOAT value , value_a;
    int src,mic,fft;


    for (src = 0 ; src < g.Nsrc ; src++) {
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0; fft < g.Nfft; fft++) {
                value_a = g.TmpIRvect[src][mic][fft];

                value = value_a * value_a;
                g.TmpIRvect[src][mic][fft] = value;
            }
        }
    }

}










/*-----------------------------------------------------------------------------*
* @brief Impulse応答の総和を求める.（SRCごと）
*
*
*  in  : tmp_IRvector
*  out : float sum
*
*-----------------------------------------------------------------------------*/
float harktool_sumAll(int src , int type)
{

    int mic,fft;
    float sum = 0;

    switch (type) {
    case normalize_src:
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0; fft < g.Nfft; fft++) {
                sum = sum + g.TmpIRvect[src][mic][fft] ;
            }
        }

        break;

//  case normalize_mic:
//  case normalize_freq:

    }

    return sum;
}










/*-----------------------------------------------------------------------------*
* Impulse応答の要素を指定した数値で割る
*
*
*   in  : int   src
*       : float sum
*       : int   type
*       : ir_tmp_vector[][][]
*   out : IRvector[][][]
*
*-----------------------------------------------------------------------------*/
void harktool_divAll(int src , float sum , int type)
{

    int mic,fft;


    switch (type) {
    case normalize_src:
        for (mic = 0 ; mic < g.Nmic ; mic++) {
            for (fft = 0; fft < g.Nfft; fft++) {
                g.IRvect[src][mic][fft] = g.IRvect[src][mic][fft] / sum ;
            }
        }

        break;

    default:
        break;

    }

}//end















/*-----------------------------------------------------------------------------*
* 伝達関数をZipファイルに出力する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_writeTF()
{

    int ret;



    //harkio_TransferFunction型にセット

    switch (g.PosType) {
    case TSP:
        g.TF = harkio_TransferFunction_fromData(g.tsp_xml->poses
                                                , g.mic_xml->poses
                                                , g.tsp_xml->cfg
                                                , g.tsp_xml->nbrs);
        break;

    case IMPULSE:
        g.TF = harkio_TransferFunction_fromData(g.impulse_xml->poses
                                                , g.mic_xml->poses
                                                , g.impulse_xml->cfg
                                                , g.impulse_xml->nbrs);
        break;

    default:
        harktool_LogE("harkio_TransferFunction_write error");
        harktool_Exit(EXIT_FAILURE);
    }


    //伝達関数をセット
    switch (g.argv.tf_type) {
    case LOC:// LOCALIZATION
        harkio_TransferFunction_setLocTFs(g.TF, g.Loctf);
        break;

    case SEP: // SEPARATION
        harkio_TransferFunction_setSepTFs(g.TF, g.Septf);
        break;

    case LOC_SEP:
        harkio_TransferFunction_setLocTFs(g.TF, g.Loctf);
        harkio_TransferFunction_setSepTFs(g.TF, g.Septf);
        break;
    }


    ret = harkio_TransferFunction_write(g.TF , g.argv.output , NULL);

    if (ret == EXIT_FAILURE) {
        harktool_LogE("harkio_TransferFunction_write error");
        harktool_Exit(EXIT_FAILURE);
    }

}//end









/*-----------------------------------------------------------------------------*
* mic分のfltファイルをwavファイルに結合する
*
* harktool_wave_from_flt()
*
*
*
*
float_ch1.flt
float_ch2.flt
float_ch3.flt
float_ch4.flt
float_ch5.flt
float_ch6.flt
float_ch7.flt
float_ch8.flt
*-----------------------------------------------------------------------------*/
void harktool_mergeFltFile(char *in_file_path , char *out_file_path , int id  ,int *outlist , int nmic , int samplerate)
{

    FILE *fpr;
    char  fname[PATH_LEN] ;
    int   frame;
    long  file_size ,fz ;
    int   mic;
    char  o_fname[PATH_LEN];
    char  i_fname[PATH_LEN];
    float **o_buf;
    float *w_buf;


    /*---------------------------------------------*/
    //tmp領域作成
    /*---------------------------------------------*/
    //1ch目のファイル名
    memset(fname , '\0' , PATH_LEN);

    sprintf(fname , "%s_ch%d.flt" , in_file_path , 1);

    //1ch分のファイルサイズ調査
    harktool_getFileSize(fname , &file_size);

    fz = file_size / sizeof(float);

    o_buf = harktool_newFloatTwoDim(nmic , fz);


    /*---------------------------------------------*/
    // 結合
    /*---------------------------------------------*/
    //結合後のwavファイル名 IR_00001.wav
    sprintf(o_fname ,"%s/imp%05d.wav" , out_file_path , id);

    for (mic=0 ; mic< nmic ; mic++) {
        sprintf(i_fname , "%s_ch%d.flt" , in_file_path , outlist[mic]);

        fpr = fopen(i_fname , "rb");

        if (fpr == NULL) {
            char msg[MSG_LEN];
            sprintf(msg, "can not open file [%s] \n", fname);
            harktool_LogE(msg);
            harktool_freeFloatTwoDim(o_buf , nmic);
            harktool_Exit(EXIT_FAILURE);
        }


        memset(o_buf[mic] , '\0' , file_size);

        fread(o_buf[mic]
              , sizeof(float) // sizeof(float)サイズ
              , fz            // fz個取得
              , fpr);


        fclose(fpr);

    }//mic end



    w_buf = (float*)malloc(sizeof(float)*nmic * fz);

    if (w_buf == NULL) {
        harktool_LogE("can not allocated memory");
        harktool_freeFloatTwoDim(o_buf , nmic);
        harktool_Exit(EXIT_FAILURE);
    }

    memset(w_buf , '\0' , (sizeof(float)*nmic * fz));

    int cnt=0;
    for (frame=0 ; frame<fz ; frame++) {
        //1fram bun
        for (mic=0 ; mic<nmic ; mic++) {
            w_buf[cnt] = o_buf[mic][frame];
            cnt++;
        }

    }


    harktool_writeWavFile(o_fname , w_buf , fz , nmic ,samplerate);


    harktool_freeFloatTwoDim(o_buf , nmic);
    free(w_buf);


}//end








/*-----------------------------------------------------------------------------*
* 結合したFLTファイルをWavファイルとして出力する
*
* harktool_CreateWavfilefromFlt()
*
* Argument
*
*  char *fname   : 変換後のwavファイル名
*  float *buffer : 結合したファイル名
*  int ndata     : frame数(file_size / sizeof(float))
*-----------------------------------------------------------------------------*/
void harktool_writeWavFile(char *fname, float *buffer , int frames , int nmic , int samplerate)
{

    SNDFILE* sfile;
    SF_INFO  sfinfo;

    sfinfo.samplerate = samplerate;
    sfinfo.channels   = nmic;
    sfinfo.format     = SF_FORMAT_WAV | SF_FORMAT_PCM_32;
    //   sfinfo.format     = SF_FORMAT_WAV | SF_FORMAT_PCM_16;



    sf_count_t ndata = frames;

    sfile = sf_open(fname, SFM_WRITE, &sfinfo);

    //writeした内容にあわせて自動的に headerを更新してくれる。
    //  sf_command( sf, SFC_SET_UPDATE_HEADER_AUTO, NULL, SF_TRUE );

    sf_writef_float(sfile, buffer, ndata) ;

    sf_close(sfile);

}//end











/*-----------------------------------------------------------------------------*
* 定位伝達関数の配列からharkio_Matrix型に変換する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setLoctfFromArray()
{

    int len;
    int src,mic,fft;


    len = g.Nmic * (g.Nfft/2+1);

    //Nsrc個 harkio_matrix を作成
    g.Loctf = (harkio_Matrix**)malloc(sizeof(harkio_Matrix*) * g.Nsrc) ;

    if (g.Loctf == NULL) {
        harktool_LogE("malloc Failed");
        harktool_Exit(EXIT_FAILURE);
    }



    for (src=0; src< g.Nsrc ; src++) {
        g.Loctf[src] = harkio_Matrix_new("complex" , g.Nmic , (g.Nfft/2+1));   //1 source bun

        if (g.Loctf[src] == NULL) {
            harktool_LogE("harkio_Matrix_new Failed");
            harktool_Exit(EXIT_FAILURE);
        }

        memset(g.Loctf[src]->data.complexdata , '\0' , len * sizeof(COMPLEX_TYPE));

        for (mic=0 ; mic<g.Nmic ; mic++) {
            for (fft=0 ; fft< (g.Nfft/2+1) ; fft++) {
                harkio_Matrix_setValueComplex(g.Loctf[src] , mic , fft , g.TFvect[src][mic][fft]);
            }
        }
    }

}//end






/*-----------------------------------------------------------------------------*
* 分離伝達関数の配列からharkio_Matrix型に変換する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setSeptfFromArray()
{

    int len;
    len = g.Nmic * (g.Nfft/2+1);
    int src ,mic,fft;

    //Nsrc個 harkio_matrix を作成
    g.Septf = (harkio_Matrix**)malloc(sizeof(harkio_Matrix*) * g.Nsrc) ;

    if (g.Septf == NULL) {
        harktool_LogE("malloc Failed");
        harktool_Exit(EXIT_FAILURE);
    }



    for (src=0; src< g.Nsrc ; src++) {
        g.Septf[src] = harkio_Matrix_new("complex" , g.Nmic , (g.Nfft/2+1));  //1 source bun
//        g.Septf[src] = harkio_Matrix_new( "complex" , 1 , len );//1 source bun

        if (g.Septf[src] == NULL) {
            harktool_LogE("harkio_Matrix_new Failed");
            harktool_Exit(EXIT_FAILURE);
        }


        memset(g.Septf[src]->data.complexdata , '\0' , len * sizeof(COMPLEX_TYPE));

        for (mic=0 ; mic<g.Nmic ; mic++) {
            for (fft=0 ; fft<(g.Nfft/2+1) ; fft++) {
                harkio_Matrix_setValueComplex(g.Septf[src] , mic , fft , g.TFvect[src][mic][fft]);
//                g.Septf[src]->data.complexdata[mic] = crealf( g.TFvect[src][mic][fft] ) + cimagf( g.TFvect[src][mic][fft] ) * _Complex_I;


            }
        }
    }

}//end





/*-----------------------------------------------------------------------------*
* 伝達関数の最後の要素を0にする
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setZeroToTFvect()
{

    int src , mic , fft;
    float real =0.0f;
    float imag =0.0f;


    fft = g.Nfft/2; //最後の値

    //最後の値に"0"をセット
    for (src=0; src< g.Nsrc ; src++) {
        for (mic=0 ; mic< g.Nmic; mic++) {
            g.TFvect[src][mic][fft] = real + imag * _Complex_I;
        }
    }


}//end







/*-----------------------------------------------------------------------------*
* 終了処理
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_freeMemory()
{

    /*
        harktool_freeComplexThreeDim( g.TFvect , g.Nsrc , g.Nmic  );
        harktool_freeComplexThreeDim( g.TmpTFvect , g.Nsrc , g.Nmic  );
        harktool_freeFloatThreeDim( g.IRvect , g.Nsrc , g.Nmic  );
        harktool_freeFloatThreeDim( g.TmpIRvect, g.Nsrc , g.Nmic  );
        harktool_freeFloatTwoDim( g.wav.data , g.Nsrc );
        harktool_freeFloatTwoDim( g.MicPosVect, g.Nmic );
        harktool_freeCharTwoDim( g.tmp.flt_path , g.Nsrc  );
        harktool_freeCharTwoDim( g.tmp.tsp_wav_name , g.Nsrc  );
    //  harktool_freeCharTwoDim( g.tmp.ir_wav_path , g.Nsrc  );
        harktool_freeIntOneDim( g.MicPosId  );
        harktool_freeIntOneDim( g.IrPosId   );
        harktool_freeComplexOneDim( g.buff_a  );
        harktool_freeComplexOneDim( g.buff_A  );
        harktool_freeComplexOneDim( g.buff_w  );
    */

    harktool_delete(TF_VECT);
    harktool_delete(TMP_TF_VECT);
    harktool_delete(IR_VECT);
    harktool_delete(TMP_IR_VECT);
    harktool_delete(WAV_DATA);
    harktool_delete(MIC_POS_VECT);
    harktool_delete(FLT_PATH);
    harktool_delete(TSP_WAV_NAME);
    harktool_delete(SORT_POS_ID);
    harktool_delete(BUFFER);






    if (g.mic_xml     != NULL)  free(g.mic_xml)           ;  // 伝達関数作成時のマイク位置
    if (g.tsp_xml     != NULL)  free(g.tsp_xml)           ;  // 伝達関数作成時の
    if (g.impulse_xml != NULL)  free(g.impulse_xml)       ;  // 伝達関数作成時の
    if (g.noise_xml   != NULL)  free(g.noise_xml)         ;  // 伝達関数作成時の;
    if (g.src_xml     != NULL)  free(g.src_xml)           ;  // 定位した音源（音源定位結果保存形式）

    //TF delete
    harkio_TransferFunction_delete(&g.TF);


}//














/*-----------------------------------------------------------------------------*
* 座標(position->sys)が極座標の場合は、直交座標に変換して再設定する
*
*
*
*-----------------------------------------------------------------------------*/
/*
void harktool_setPosition( int type )
{

    switch( type )
    {
    case MIC:
        harktool_convertCoordMicPos();
        break;


    case SRC:
        harktool_convertCoordSrcPos();
        break;

    }

}//
*/


/*-----------------------------------------------------------------------------*
* 座標(position->sys)が極座標の場合は、直交座標に変換して再設定する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setMicPos()
{

    int ret;
    float a_coord[3];
    int mic_id;
    harkio_Position* pos;
    int mic;


    for (mic= 0 ; mic< g.Nmic ; mic++) {
        mic_id = g.MicPosId[mic] ;//昇順でsort済

        //mic_idのpositionを取得
        pos = harkio_Positions_getById(g.mic_xml->poses , mic_id);


        if (pos->sys == Polar) {
            ret = harkio_Position_Convert(pos , a_coord , Cartesian);

            if (ret == EXIT_FAILURE) {
                harkio_Log_printf(harkio_Log_Error , "harkio_Position_Convert error");
                harktool_Exit(EXIT_FAILURE);
            }

            g.MicPosVect[mic][0] = a_coord[0]; // x
            g.MicPosVect[mic][1] = a_coord[1]; // y
            g.MicPosVect[mic][2] = a_coord[2]; // z
        } else {

            g.MicPosVect[mic][0] = pos->coord[0]; // x
            g.MicPosVect[mic][1] = pos->coord[1]; // y
            g.MicPosVect[mic][2] = pos->coord[2]; // z
        }

    }

}//end







/*-----------------------------------------------------------------------------*
* 座標(position->sys)が極座標の場合は、直交座標に変換して再設定する
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setSrcPos()
{

    int ret;
    float coord[3];
    int tsp_id;
    harkio_Position* pos;
    int src;

    for (src= 0 ; src< g.Nsrc ; src++) {
        tsp_id = g.TspPosId[src] ;

        //tsp_idのpositionを取得
        pos = harkio_Positions_getById(g.tsp_xml->poses , tsp_id);


        if (pos->sys == Polar) {
            ret = harkio_Position_Convert(pos , coord , Cartesian);

            if (ret == EXIT_FAILURE) {
                harktool_Exit(EXIT_FAILURE);
            }


            g.SrcPosVect[src][0] = coord[0]; // x
            g.SrcPosVect[src][1] = coord[1]; // y
            g.SrcPosVect[src][2] = coord[2]; // z
        } else {

            g.SrcPosVect[src][0] = pos->coord[0]; // x
            g.SrcPosVect[src][1] = pos->coord[1]; // y
            g.SrcPosVect[src][2] = pos->coord[2]; // z
        }
    }

}//end




/*-----------------------------------------------------------------------------*
* mic positionの平均
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_calcMicPosMean()
{

    int i;
    float position_sum[3];


    for (i=0 ; i<3 ; i++) {
        position_sum[i]  = 0;
        g.PosMean[i] = 0;
    }


    for (i=0 ; i< g.Nmic ; i++) {
        position_sum[0] = position_sum[0] + g.MicPosVect[i][0];
        position_sum[1] = position_sum[1] + g.MicPosVect[i][1];
        position_sum[2] = position_sum[2] + g.MicPosVect[i][2];
    }


    g.PosMean[0] = position_sum[0] / g.Nmic;
    g.PosMean[1] = position_sum[1] / g.Nmic;
    g.PosMean[2] = position_sum[2] / g.Nmic;



}//














/*-----------------------------------------------------------------------------*
* MIC ID 並べ替え
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setMicPosId()
{

    int mic;

    for (mic=0 ; mic< g.Nmic ; mic++) {
        g.MicPosId[mic] = g.mic_xml->poses->pos[mic]->id;
    }

    //並べ替え
    harktool_BubSort(g.MicPosId , g.Nmic);

}//






/*-----------------------------------------------------------------------------*
* impulse応答 id 並べ替え
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setIrPosId()
{
    int src;

    for (src=0 ; src< g.Nsrc ; src++) {
        g.IrPosId[src] = g.impulse_xml->poses->pos[src]->id;
    }

    //並べ替え
    harktool_BubSort(g.IrPosId , g.Nsrc);

}//






/*-----------------------------------------------------------------------------*
* TSP id 並べ替え
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_setTspPosId()
{

    int src;



    for (src=0 ; src< g.Nsrc ; src++) {
        g.TspPosId[src] = g.tsp_xml->poses->pos[src]->id;
    }


    //並べ替え
    harktool_BubSort(g.TspPosId , g.Nsrc);

}//







/*-----------------------------------------------------------------------------*
* ソート処理
*
*
*
*-----------------------------------------------------------------------------*/
/* バブルソートを行う */
void harktool_BubSort(int x[ ], int n)
{
    int i, j, temp;

    for (i = 0; i < n - 1; i++) {
        for (j = n - 1; j > i; j--) {
            if (x[j - 1] > x[j]) {  /* 前の要素の方が大きかったら */
                temp = x[j];        /* 交換する */
                x[j] = x[j - 1];
                x[j - 1]= temp;
            }
        }
    }

    harktool_ShowData(x,  n);
}


/* ソート対象のデータを表示 */
void harktool_ShowData(int x[ ], int n)
{
    int i;

    for (i = 0; i < n ; i++) {
        printf("x[%d]=%d ", i, x[i]);

    }

    printf("\n");
}











/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
long get_flt_size(const char* fname)
{
    if (fname == NULL) {
        return -1;
    }

    FILE* fd = fopen(fname, "rb");

    if (fd == NULL) {
        return -1;
    }

    fseek(fd, 0, SEEK_END);
    long file_size = ftell(fd);

    fclose(fd);

    return file_size;
}


/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
int read_flt(const char* fname, double* dBuf, size_t file_size, double* signal_max)
{
    if (fname == NULL || dBuf == NULL || signal_max == NULL ||
            (file_size % sizeof(float)) != 0) {
        return -1;
    }

    FILE* fd = fopen(fname, "rb");

    if (fd == NULL) {
        return -1;
    }

    char file_buf[BUFSIZ];
    setvbuf(fd, file_buf, _IOFBF, BUFSIZ); // full buffering

    int result = 0;
    float read_buf;
    *signal_max = 0;
    size_t i;

    for (i = 0; i < file_size / sizeof(float); ++i) {
        size_t r = fread((void*)&read_buf, sizeof(float), 1, fd);
        if (r < 1) {
            // error
            result = -1;
            break;
        }
        dBuf[i] = (double) read_buf;
        const double amp = fabs(dBuf[i]);
        if (amp > *signal_max) {
            *signal_max = amp;
        }
    }

    fclose(fd);
    return result;
}



/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
int write_flt(const char* fname, const double* dBuf, size_t count)
{
    if (fname == NULL || dBuf == NULL) {
        return -1;
    }


    FILE* fd = fopen(fname, "wb");

    if (fd == NULL) {
        return -1;
    }

    char file_buf[BUFSIZ];
    setvbuf(fd, file_buf, _IOFBF, BUFSIZ); // full buffering

    int result = 0;
    float write_buf;
    int i;

    for (i = 0; i < count; ++i) {
        write_buf = (float)dBuf[i];

        size_t r = fwrite((void*)&write_buf, sizeof(float), 1, fd);
        if (r < 1) {
            // error
            result = -1;
            break;
        }
    }

    fflush(fd);
    fclose(fd);
    return result;
}








/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
// open wave file
SNDFILE *waveopen(char *path, int sfmode, SF_INFO *sfinfo)
{

    SNDFILE *fp;

    sfinfo->format = 0;
    if ((fp = sf_open(path, sfmode, sfinfo)) == NULL) {
        perror("sf_open");
        return NULL;
    }
    return fp;
}



/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
// read wave data
int readwave(SNDFILE *fp, SF_INFO *sfinfo, int count, double ***wave)
{

    int *data;
    int i, j;
    double normalize_ratio;

//  double norm_A = 32768;
//  double norm_B = 65536;


    switch ((sfinfo->format) & (SF_FORMAT_SUBMASK)) {
    case SF_FORMAT_PCM_S8:
        printf("Reading 8bitWave ...\n");
//            normalize_ratio = norm_A * norm_B; break;
        normalize_ratio = 32768 * 65536L;
        break;
    case SF_FORMAT_PCM_16:
        printf("Reading 16bitWave ...\n");
//            normalize_ratio = norm_A * norm_B; break;
        normalize_ratio = 32768 * 65536L;
        break;
    case SF_FORMAT_PCM_24:
        printf("Reading 24bitWave ...\n");
//            normalize_ratio = norm_A * norm_B; break;
        normalize_ratio = 32768 * 65536L;
        break;
    case SF_FORMAT_PCM_32:
        printf("Reading 32bitWave ...\n");
//            normalize_ratio = norm_A * norm_B; break;
        normalize_ratio = 32768 * 65536L;
        break;
    default :
        printf("Reading other Wave ...\n");
//            normalize_ratio = norm_A * norm_B; break;
        normalize_ratio = 32768 * 65536L;
        break;
    }

    if ((data = (int *) malloc(sizeof(int) * count * sfinfo->channels)) == NULL) {
        perror("malloc");
        exit(0);
    }

    memset(data, 0, sizeof(int) * count * sfinfo->channels);

    if ((*wave = (double **) malloc(sizeof(double *) * sfinfo->channels)) == NULL) {
        perror("malloc");
        exit(0);
    }

    for (i = 0; i < sfinfo->channels; i++) {
        if (((*wave)[i] = (double *) malloc(sizeof(double) * count)) == NULL) {
            perror("malloc");
            exit(0);
        }
    }

    sf_readf_int(fp, data, count);

    // normalize_ratio = 32768 * 65536;
    // normalize_ratio = -normalize_ratio;

    for (i = 0; i < count; i++) {
        for (j = 0; j < sfinfo->channels; j++) {
            (*wave)[j][i] = (((double) data[j + i * sfinfo->channels]) / normalize_ratio);
        }
    }

    free(data);

    return 1;
}



/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
// read wave file
int readwavfile(char *fname, double ***wave, int *length, int *ch, int *samplerate)
{
    SNDFILE *fp;
    SF_INFO sfinfo;

    sfinfo.format = 0;
    if ((fp = sf_open(fname, SFM_READ, &sfinfo)) == NULL) {
        return -1;
    }
    readwave(fp, &sfinfo, sfinfo.frames, wave);
    sf_close(fp);
    *length = sfinfo.frames;
    *ch = sfinfo.channels;
    *samplerate = sfinfo.samplerate;

    return 1;
}




/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
// write wave data
int writewave(SNDFILE *fp, SF_INFO *sfinfo, int count, double **wave)
{

    short *data;
    int i, j;

    if ((data = (short *) malloc(sizeof(short) * count * sfinfo->channels)) == NULL) {
        perror("malloc");
        exit(0);
    }

    for (i = 0; i < count; i++)
        for (j = 0; j < sfinfo->channels; j++) {
            data[j + i * sfinfo->channels] = (short) wave[j][i];
        }

    sf_writef_short(fp, data, count);

    free(data);

    return 1;
}





/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
// read wave file
int writewavfile(char *fname, double **wave, int length, int ch, int samplerate)
{
    SNDFILE *fp;
    SF_INFO sfinfo;

    sfinfo.format = SF_FORMAT_WAV | SF_FORMAT_PCM_16;
    sfinfo.samplerate = samplerate;
    sfinfo.channels = ch;
    sfinfo.sections = -1;
    sfinfo.seekable = -1;
    //  sfinfo.frames = length;

    fp = sf_open(fname, SFM_WRITE, &sfinfo);
    writewave(fp, &sfinfo, length, wave);
    sf_close(fp);

    return 1;
}





/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
void setFftData()
{
    int i;
    float real,imag;

    for (i = 0; i < g.Nfft ; i++) {
        real = cosf(two_pi * i / g.Nfft);
        imag = -sinf(two_pi * i / g.Nfft);
        g.buff_w[i] = real +  imag  * _Complex_I;
    }
}










/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
void harktool_setChannelList()
{

    int i = 0;
    char buff[BUFFSIZE];

    while (i< g.Nmic) {
        sprintf(buff,"%d," , i);
        strcat(g.ChannelList ,  buff);
        i++;
    }

    g.ChannelList[ strlen(g.ChannelList)-1 ] = 0;  //最後のカンマを削除

}











void Print_calcSysImp(char *path)
{

    printf("harktool_calcSysImp  15 \n");
    printf("                    , --tsporigwav     [%s]\n" , g.OrgTspPath);            // "/usr/bin/harktool4_utils/16384.little_endian.wav"
    printf("                    , --sigmax         [%d]\n" , g.SignalMax);          // "32768"
    printf("                    , --syncaddfreq    [%d]\n" , g.SyncAverage);        // "16"
    printf("                    , --syncaddoffset  [%d]\n" , g.TspOffset);          // "16384"
    printf("                    , --outchannellist [%s]\n" , g.ChannelList);              //"0,1,2,3,4,5,6,7"
    printf("                    , --inputwave      [%s]\n" , path);                // "/home/circle360_5deg_H115_R150_D180_1.wav"
    printf("                    , --outputpath     [%s]\n" , g.tmp.outimpfilehead);   // "/tmp/harktool/20140101/tsp/circle360_5deg_H115_R150_D180_1.wav/float"


}








/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
COMPLEX_FLOAT COMPLEX_FLT(COMPLEX_FLOAT z)
{
    return crealf(z) + cimagf(z) * _Complex_I;
}


/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
COMPLEX_DOUBLE COMPLEX_DBL(double real , double imag)
{

    return real + imag * _Complex_I;
}










/*----------------------------------------------------------*/
/*                                                          */
/*----------------------------------------------------------*/
void createReadMeToZipFile(char *zip_path)
{

    char str[1024];
    int errorp;
    struct zip *s;
    struct zip_source *src;

    memset(str , '\0' , sizeof(str));


    sprintf(str ,"%s \n%s[%d]\n%s[%d]\n%s[%d]\n"
            ,"Normalization Type"
            ,"- Source     " , g.argv.normalize_src
            ,"- Microphone " , g.argv.normalize_mic
            ,"- Frequency  " , g.argv.normalize_freq);





    //file open
    s = zip_open(zip_path , ZIP_CREATE , &errorp);

    if (s == NULL) {
        char msg[MSG_LEN];
        sprintf(msg, "zip open error errorp[%d]",errorp);
        harktool_LogE(msg);
        harktool_Exit(EXIT_FAILURE);
    }

    src = zip_source_buffer(s , str, strlen(str) , 0);

    if (src == NULL) {
        harktool_LogE("zip_source_buffer error");
        harktool_Exit(EXIT_FAILURE);
    }


    zip_add(s , "transferFunction/README", src);

    zip_close(s);


}






/*-----------------------------------------------------------------------------*
* 終了処理
*
*
*
*-----------------------------------------------------------------------------*/
void harktool_Exit(int exit_type)
{

    if (exit_type == EXIT_SUCCESS) {
        harktool_LogI("harktool normal end");
        harktool_freeMemory();
        exit(EXIT_SUCCESS);
    }


    harktool_LogE("harktool abnormal end");

    harktool_freeMemory();

    exit(EXIT_FAILURE);

}//end







void harktool_genMUSIC()
{
    // wavファイルからIR変換
    harktool_setIRvectFromWav();

    // 残響音と思われる部分に0を書き込む
    harktool_EraseReverberation();

    // 残響音が直接音より大きい可能性がある音源を表示
    harktool_ShowReverbSources();

    // インパルス応答をFFTして伝達関数を取得
    harktool_FFT();

    //定位伝達関数の配列からharkio_Matrix型に変換する
    harktool_setLoctfFromArray();

}



void harktool_genGSS()
{

    /* インパルス応答の正規化 */
    harktool_normalizeIR();


    // インパルス応答をFFTして伝達関数を取得
    harktool_FFT();

    /* conj */
    harktool_conjTF();

    harktool_normalizeTF();

    //分離伝達関数の配列からharkio_Matrix型に変換する
    harktool_setSeptfFromArray();

}






